#!/usr/bin/env python3

# Requires python-z3-solver
# Usage: ./solve.py | xxd -r -ps | wine win32.exe

from z3 import *

import binascii

password = [BitVec(f'password[{i}]', 16) for i in range(9)]

checkBytes = [0xE9, 0xF1, 0xF0, 0xCE, 0x95, 0x8, 0x5A, 0xBA, 0x15, 0x0]


s = Solver()

s.add(checkBytes[8] == ~password[6])

checkBytes2 = BitVec('checkBytes2', 16)
s.add(checkBytes[5] == (password[5] >> (password[7] % 5) << (password[7] % 5)) + (password[4] & 0xF))
s.add(checkBytes2 == 4 * password[2])
s.add(checkBytes[7] == 2 * password[7] - ord('p'))
s.add(checkBytes[3] == password[7] + password[3])

s.add(checkBytes[0] == password[0] + 23)
s.add(checkBytes[4] == (password[5] & 0xF) + (password[4] >> (password[7] % 5) << (password[7] % 5)))

s.add(checkBytes[2] == checkBytes2 - (2 * password[2]))
s.add(checkBytes[6] == (password[0] - password[2]))
s.add(checkBytes[1] == 96 ^ password[1])

s.add(checkBytes[9] == password[8])


s.check()

m = s.model()

heslo = []
for i in range(9):
    heslo.append(int(str(m.evaluate(password[i]))) % 256)

print(binascii.hexlify(bytes(heslo)).decode())
